/**
 * @license
 * Copyright (c) 2014, 2020, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
/*
 * Your application specific code will go here
 */

'use strict';
require(['knockout', 'ojs/ojbootstrap', 'ojs/ojarraydataprovider',
        'ojs/ojknockout', 'ojs/ojcheckboxset', 'ojs/ojbutton', 'ojs/ojselectcombobox', 'ojs/ojvalidationgroup', 'featureListData'],
    function (ko, Bootstrap, ArrayDataProvider, ojvalidationgroup) {
    function viewModel() {
        var styleTag = $('#inlineStyleTag');
        // to set all of the labelHint tags use this:
        // styleTag.html('.oj-label { color: white; }');
        // to set just the combobox labelHint tags use:
        //  styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: white; }');

        // styleTag.html('.oj-text-field-label-inside.oj-text-field:not(.oj-read-only):not(.oj-has-no-value) .oj-text-field-container .oj-label { color: green; }');
        //  this.selectedProduct = ko.observableArray(['P6 EPPM']);

        // styleTag.html('.oj-helphints-inline-container { color: white; }')

        this.selectedProduct = ko.observableArray(['']);
        this.selectedProduct(['P6 EPPM']);
        // this.selectedProduct = ko.observableArray([]);
        this.selectedRelease = ko.observableArray(['']);
        this.selectedTarget = ko.observableArray(['']);
        this.productCurrentHint = ko.observable("");
        this.releaseCurrentHint = ko.observable("");
        this.releaseTargetHint = ko.observable("");
        this.groupValid = ko.observable();
        // invalidHidden

        this.productCurrentHint("Enabled");
        this.releaseCurrentHint("Enabled");
        this.releaseTargetHint("Enabled");

        //*****************************************

        var UniqueProductIndex1 = {};
        var UniqueProductIndex2 = [];

        var UniqueReleaseIndex1 = {};
        var UniqueTargetIndex1 = {};
        var UniqueReleaseIndex2 = [];
        var UniqueTargetIndex2 = [];
        var maxNumFeatures;
        var CurProductList = [];
        var applicationName = getData("applicationName");
        var featureList = getData();
        var i;
        var initialProduct;
        var SearchString;
        var productFlag;
        var verFlag;
        var v;
        var c;
        var tarFlag = 0;
        var t;
        var testList;
        var latestEventDetailValue;
        var createReport;
        var disabledValue = document.getElementById("buttonid");
        var checkboxset1 = document.getElementById("checkboxset1");
        var initialTarget;
        var initialRelease;
        var CurRelBoxList;
        var CurTarBoxList;
        var FullRelBoxList;
        var FullTarBoxList;
        var featureListValue;
        var featureListValueProcessed;
        var n;
        //var tempCurTarBoxList;
        if (applicationName) {
            this.appName = applicationName;
        } else {
            this.appName = "";
        }

        if (featureList.length) {
            maxNumFeatures = featureList.length;
        } else {
            maxNumFeatures = 0;
        }

        for (i = 0; i < maxNumFeatures; i++) {
            featureListValue = featureList[i].ftrRelease;
            featureListValueProcessed = "";
            if (featureListValue && featureListValue !== "") {
                featureListValue = featureListValue.split('.');
                if (featureListValue.length && (featureListValue.length < 4)) {
                    for (n = 0; n < featureListValue.length; n++) {
                        if (n === 0 && (Number(featureListValue[n] !== 'NaN'))) {
                            featureListValueProcessed = (Number(featureListValue[n])) * 1000;
                        }
                        if (n === 1 && (Number(featureListValue[n] !== 'NaN'))) {
                            featureListValueProcessed += (Number(featureListValue[n])) * 10;
                        }
                        if (n === 2 && (Number(featureListValue[n] !== 'NaN'))) {
                            featureListValueProcessed += (Number(featureListValue[n]));
                        } else if ((Number(featureListValue[n] === 'NaN'))) {
                            if (featureList[i].itemNo) {
                                console.log((Number(featureListValue[n] !== 'NaN')) + "_Release id " + featureList[i].ftrRelease + " for item number " + featureList[i].itemNo + " is not a valid release number");
                            } else {
								 console.log("Release id " + featureList[i].ftrRelease + "is not a valid release number");
							}
                        }
                    }

                } else {
                    if (featureList[i].itemNo) {
                        console.log("Invalid number of delmiters in release id " + featureList[i].ftrRelease + " for item number " + featureList[i].itemNo);
                    } else {
                        console.log("Invalid release id");
                    }
                }
            } else {
                if (featureList[i].itemNo) {
                    console.log("Invalid release id for item number " + featureList[i].itemNo);
                } else {
                    console.log("Invalid release id");
                }

            }
            if (featureList && featureList[i].product && featureList[i].product !== "") {

                UniqueProductIndex1[featureList[i].product] = featureList[i].product;
            }
            if (featureList && featureList[i].ftrRelease && featureListValueProcessed && featureListValueProcessed !== '') {
                featureList[i].index = featureListValueProcessed.toString();
            } else {
                console.log("Invalid release id. Release has not added to the list of releases");
                featureList[i].index = null;
            }
        }

        for (const[key, value]of Object.entries(UniqueProductIndex1)) {
            UniqueProductIndex2.push({
                value: `${key}`,
                label: `${value}`
            });

        }

        for (i = 0; i < featureList.length; i++) {
            UniqueReleaseIndex1[featureList[i]['index']] = featureList[i]['ftrRelease'];
        }

        for (const[key, value]of Object.entries(UniqueReleaseIndex1)) {
            UniqueReleaseIndex2.push({
                value: `${key}`,
                label: `${value}`
            });

        }

        UniqueReleaseIndex2.sort(function (x, y) {
            return Number(x.value) - Number(y.value);
        });

        UniqueReleaseIndex2.splice(length - 1);

        // UniqueTargetIndex1[0] =  '';
        for (i = 0; i < featureList.length; i++) {
            UniqueTargetIndex1[featureList[i]['index']] = featureList[i]['ftrRelease'];
        }
        for (const[key, value]of Object.entries(UniqueTargetIndex1)) {
            UniqueTargetIndex2.push({
                value: `${key}`,
                label: `${value}`
            });

        }

        UniqueTargetIndex2.sort(function (x, y) {
            return Number(y.value) - Number(x.value);
        });

        UniqueTargetIndex2.splice(length - 1);

        CurProductList = UniqueProductIndex2;

        this.product = ko.observable(new ArrayDataProvider(CurProductList, {
                    keyAttributes: 'value'
                }));

        // this.selectedProduct([]);
        initialProduct = this.product._latestValue.data[0].label
            if (initialProduct) {
                this.selectedProduct([initialProduct]);
            }
            // this.selectedProduct(['P6 EPPM']);

            CurRelBoxList = UniqueReleaseIndex2.reverse();
        //CurRelBoxList = UniqueReleaseIndex2;
        FullRelBoxList = CurRelBoxList;

        //release = ko.observable(new ArrayDataProvider(CurRelBoxList, {keyAttributes: ['value', 'label']}));

        this.release = ko.observable(CurRelBoxList, {
            keyAttributes: ['value', 'label']
        });

        CurTarBoxList = UniqueTargetIndex2;
        FullTarBoxList = CurTarBoxList;

        this.target = ko.observable(CurTarBoxList, {
            keyAttributes: ['value', 'label']
        });
        //tempCurTarBoxList = UniqueTargetIndex2;
        //target = ko.observable(new ArrayDataProvider(CurTarBoxList, {keyAttributes: ['value', 'label']}));


        // initialTarget = this.selectedTarget._latestValue;
        // initialRelease = this.selectedRelease._latestValue;
        SearchString = getSearchString();
        if (SearchString && SearchString["product"]) {
            for (c = 0; c < CurProductList.length; c++) {
                if (CurProductList[c]['label'].toLowerCase() === SearchString["product"]) {
                    productFlag = CurProductList[c]['label'];
                    break;
                }
            }
        }

        if (productFlag) {
            this.selectedProduct([productFlag]);
        } else {
            if (CurProductList && CurProductList.length > 1 && CurProductList[1].label === 'P6 EPPM') {
                this.selectedProduct(['P6 EPPM']);
            } else if (CurProductList && CurProductList.length === 1) {
                this.selectedProduct([CurProductList[0]['label']]);
            }
        }
        if (SearchString && SearchString["version"]) {

            for (v = 0; v < CurTarBoxList.length; v++) {
                if (CurTarBoxList[v]['label'] === SearchString["version"]) {
                    verFlag = CurTarBoxList[v]['label'];
                    break;
                }
            }

        }

        if (verFlag) {
            for (t = 0; t < CurTarBoxList.length; t++) {
                if (CurTarBoxList[t]['label'] === verFlag) {

                    tarFlag = CurTarBoxList[t]['value'];
                    break;
                }
            }

            if (tarFlag) {

                this.selectedTarget = ko.observableArray([verFlag]);
                this.selectedTarget._latestValue = tarFlag;

            }
        }

        // the following reduces the current releases to the ones that are valid based upon the target
        testList = CurRelBoxList.filter(function (CurRelBoxList) {
            if (CurRelBoxList.value < tarFlag)
                return CurRelBoxList;
        });

        if (testList && testList.length > 0) {
            this.release(testList, {
                keyAttributes: ['value', 'label']
            });
        }

        if (UniqueProductIndex2 && UniqueProductIndex2.length && UniqueProductIndex2.length === 1) {
            $('#CurProductDiv').css("display", "none");
        }

        this.eventListener = function (event, current, bindingContext) {

            latestEventDetailValue = event.detail.value;
            createReport = false;
            this.isValidEntry(event, current, createReport, latestEventDetailValue);
            if (event.detail.value) {
                switch (event.detail.value) {
                case "invalidShown":
                    if (disabledValue) {
                        disabledValue.disabled = true;
                    }
                    this.isValid = false;
                    console.log("invalidShown ");
                    // styleTag.html('.oj-label { color: red; }');
                    this.productCurrentHint("At least one product must be selected");
                    // styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                    break;
                case "pending":
                    //isValid = false;

                    // document.getElementById("buttonid").disabled=false;
                    break;
                case "valid":
                    this.productCurrentHint("");
                    this.releaseCurrentHint("");
                    this.releaseTargetHint("");
                    if (disabledValue) {
                        disabledValue.disabled = false;
                    }
                    this.isValid = true;
                    $('#curMsgDiv').css("display", "none");
                    //styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: white; }');
                    //styleTag.html('.oj-label { color: white; }');

                    break;
                }
            }
        }
        .bind(this);

        this.isValidEntry = function (event, current, createReport, latestEventDetailValue) {

            var selectedProductValue = current.selectedProduct._latestValue;

            var selectedReleaseValue = current.selectedRelease._latestValue;
            var selectedTargetValue = current.selectedTarget._latestValue;
            // console.log("selectedTargetValue: " + selectedTargetValue);
            var cCurProductList = CurProductList;
            var vCurProductListArray = cCurProductList.filter(function (cCurProductList) {
                return cCurProductList.value === current.selectedProduct
            });

            // var cCurRelBoxList = CurRelBoxList;
            var lCurRelBoxListArray = CurRelBoxList.filter(function (CurRelBoxList) {
                return CurRelBoxList.label === selectedReleaseValue
            });

            var vCurRelBoxListArray = CurRelBoxList.filter(function (CurRelBoxList) {
                return CurRelBoxList.value === selectedReleaseValue
            });
            var valueFromLabelRelBoxListArray = CurRelBoxList.filter(function (CurRelBoxList) {
                if (CurRelBoxList.label === selectedReleaseValue)
                    return CurRelBoxList.value
            });

            // var cCurTarBoxList = CurTarBoxList;
            var lCurTarBoxListArray = CurTarBoxList.filter(function (CurTarBoxList) {
                return CurTarBoxList.label === selectedTargetValue
            })
                var vCurTarBoxListArray = CurTarBoxList.filter(function (CurTarBoxList) {
                return CurTarBoxList.value === selectedTargetValue
            })
                var valueFromLabelTarBoxListArray = CurTarBoxList.filter(function (CurTarBoxList) {
                if (CurTarBoxList.label === selectedTargetValue)
                    return CurTarBoxList.value
            });

            var lCurLargerTarBoxListArray = CurTarBoxList.filter(function (CurTarBoxList) {
                return CurTarBoxList.label > selectedReleaseValue
            })
                var vCurLargerTarBoxListArray = CurTarBoxList.filter(function (CurTarBoxList) {
                return CurTarBoxList.value > selectedReleaseValue
            })
                if (lCurRelBoxListArray.length && lCurRelBoxListArray.length > 0) {
                    if (valueFromLabelRelBoxListArray.length && valueFromLabelRelBoxListArray.length > 0) {
                        selectedReleaseValue = valueFromLabelRelBoxListArray[0].value;
                        // TYPED IN
                        this.releaseCurrentHint("");
                        this.isValidRelease = true;
                    }
                } else if (vCurRelBoxListArray.length && vCurRelBoxListArray.length > 0 && vCurRelBoxListArray[0].value === "0000") {
                    this.releaseCurrentHint("");
                    this.isValidRelease = false;
                } else if (vCurRelBoxListArray.length && vCurRelBoxListArray.length > 0) {
                    this.releaseCurrentHint("");
                    selectedReleaseValue = vCurRelBoxListArray[0].value;
                    this.isValidRelease = true;
                } else {
                    this.releaseCurrentHint("Entry is not in the list of current releases.");
                    this.isValidRelease = false;
                }
                if (lCurTarBoxListArray.length && lCurTarBoxListArray.length > 0) {
                    if (valueFromLabelTarBoxListArray.length && valueFromLabelTarBoxListArray.length > 0) {
                        selectedTargetValue = valueFromLabelTarBoxListArray[0].value;
                        // TYPED IN
                        this.releaseTargetHint("");
                        this.isValidTarget = true;
                    }
                } else if (vCurTarBoxListArray.length && vCurTarBoxListArray.length > 0 && vCurTarBoxListArray[0].value !== "0000") {
                    this.releaseTargetHint("");
                    this.isValidTarget = true;
                    selectedTargetValue = vCurTarBoxListArray[0].value;
                } else if (vCurTarBoxListArray.length && vCurTarBoxListArray.length > 0 && vCurTarBoxListArray[0].value === "0000") {
                    this.releaseTargetHint("");
                    this.isValidTarget = false;
                } else if (!vCurTarBoxListArray.length && !vCurTarBoxListArray.length > 0) {
                    this.releaseTargetHint("Enter or select a target release");

                    this.isValidTarget = false;
                } else {
                    this.releaseTargetHint("Entry is not in the list of target releases.");
                    //styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                    // styleTag.html('.oj-label { color: red; }');
                    this.isValidTarget = false;
                }

                if (this.selectedProduct._latestValue && this.selectedProduct._latestValue === "") {
                    this.productCurrentHint("At least one product must be selected");
                    this.isValidProduct = false;
                    //styleTag.html('.oj-label { color: red; }');
                    //styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: white; }');
                } else if (this.selectedProduct._latestValue) {
                    this.isValidProduct = true;
                    //productCurrentHint("At least one product must be selected");
                    //styleTag.html('.oj-label { color: white; }');
                    //styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: white; }');
                } else {
                    console.log("no product");

                }

                if (this.isValidTarget && this.isValidRelease
                     && (Array.isArray(selectedProductValue)
                         && selectedProductValue.length
                         && (selectedProductValue[0] !== ""))) {
                    this.isValid = true;
                    if (disabledValue) {
                        disabledValue.disabled = false;
                    }
                } else {
                    this.isValid = false;
                    if (disabledValue) {
                        disabledValue.disabled = true;
                    }
                }

                if (this.groupValid && this.groupValid._latestValue === "valid" && createReport) {
                    //styleTag.html('.oj-label { color: white; }');
                    //styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: white; }');
                    this.runReport2(selectedProductValue, selectedReleaseValue, selectedTargetValue, this.isValid, this.isValidProduct);
                    return true;
                    /* */
                } else if ((this.groupValid && this.groupValid._latestValue === "invalidShown" && createReport)) {
                    if (disabledValue) {
                        disabledValue.disabled = true;
                    }
                    //styleTag.html('.oj-label { color: red; }');
                    //styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                    return false;

                } else {

                    return false;
                }

        }
        .bind(this);
        this.valueChangedHandler;

        this.valueChangedHandler = function (event, current) {
            var createReport;

            if (current.selectedTarget._latestValue && Number(current.selectedTarget._latestValue) > 0) {
                CurRelBoxList = FullRelBoxList.filter(function (FullRelBoxList) {
                    return Number(FullRelBoxList.value) < Number(current.selectedTarget._latestValue)
                })
                    this.release(CurRelBoxList, {
                    keyAttributes: ['value', 'label']
                });
            }

            if (current.selectedRelease._latestValue && Number(current.selectedRelease._latestValue) > 0) {
                CurTarBoxList = FullTarBoxList.filter(function (FullTarBoxList) {
                    return Number(FullTarBoxList.value) > Number(current.selectedRelease._latestValue)
                })
                    this.target(CurTarBoxList, {
                    keyAttributes: ['value', 'label']
                });

            }

            createReport = false;
            this.isValidEntry(event, current, createReport);

        }
        .bind(this);

        this.runReport = function (event, current) {
            var createReport;
            createReport = true;
            this.isValidEntry(event, current, createReport);

        }
        .bind(this);

        this.runReport2 = function (selectedProductValue, selectedReleaseValue, selectedTargetValue, isValid, isValidProduct) {
            var tarRelId = Number(selectedTargetValue);
            var currRelId = Number(selectedReleaseValue);
            var selectedProducts = selectedProductValue;

            if (!isValid) {
                return;
            } else {}

            if (Array.isArray(selectedProducts)
                 && selectedProducts.length
                 && selectedProducts.length >= 1
                 && selectedProducts[0] !== "") {

                for (var i = 0; i < selectedProducts.length; i++) {
                    selectedProducts[i];
                    // alert("SelectedProducts: " + selectedProducts[i]);
                }

                if (currRelId == 0) {
                    // alert("You must select Current Release.")
                    this.releaseReleaseHint("You must select a current release.");
                    styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                    styleTag.html('.oj-label { color: red; }');
                    return false;

                } else {

                    if (tarRelId == 0) {
                        // document.getElementById("comboboxTarget").labelHint = "you must select Target release.";
                        // alert("you must select Target release.")
                        this.releaseTargetHint("You must select a target release.");
                        styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                        styleTag.html('.oj-label { color: red; }');

                        return false;

                    } else {

                        // Check for reasonable target release and throw the alert message
                        if (tarRelId <= currRelId) {
                            this.releaseTargetHint("Target must be higher than current.");
                            styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                            styleTag.html('.oj-label { color: red; }');
                            // alert("You must set your target release higher than your current release.")

                            return false;
                        }
                    }
                }

            } else {

                if (!isValidProduct) {
                    if (checkboxset1) {
                        checkboxset1.labelHint = 'You have not selected any Products';
                    }
                    this.productCurrentHint("You have not selected any Products.");
                    styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                    styleTag.html('.oj-label { color: red; }');
                    return false;
                }

                if (currRelId == 0) {

                    // document.getElementById("comboboxRelease").labelHint = "You must select Current Release."
                    this.releaseCurrentHint("You must select a current release.");
                    styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                    styleTag.html('.oj-label { color: red; }');
                    // alert("You must select Current Release.")

                    return false;

                } else {

                    if (tarRelId === 0) {

                        // alert("you must select Target release.")
                        this.releaseTargetHint("You must select a target release.");
                        styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                        styleTag.html('.oj-label { color: red; }');

                        return false;

                    } else {

                        // Check for reasonable target release and throw the alert message-- >
                        if (tarRelId <= currRelId) {
                            // self.releaseTargetHint("Target release must be higher than current release.");
                            //alert("You must set your target release higher than your current release.")
                            this.releaseTargetHint("Target release must be higher than current release.");
                            styleTag.html('.oj-text-field-label-inside.oj-text-field .oj-label { color: red; }');
                            styleTag.html('.oj-label { color: red; }');
                            return false;
                        }
                    }
                }

                return true;

            }

            //Load the featureList JSON data for the selected releases(Greater than Current release and upto Target release)
            var selFeatureList = [];
            var currentftrReleaseList = [];
            var currentftrRelease = "";
            var currRelItem;
            var tarRelItem;

            for (var i = 0; i < featureList.length; i++) {

                if (featureList[i].index <= tarRelId && featureList[i].index > currRelId && selectedProducts.includes(featureList[i].product)) {
                    // if (featureList[i].index <= tarRelId && featureList[i].index >currRelId){
                    selFeatureList.push(featureList[i]);

                }
                if (featureList[i].index <= tarRelId && featureList[i].index === selectedReleaseValue) {
                    currentftrReleaseList.push(featureList[i])
                }

            }

            //  cCurProductList.filter(function(cCurProductList) { return cCurProductList.value ===selectedProduct});


            currRelItem = featureList.find(function (item) {
                return item.key === item.currRelId
            })
                tarRelItem = selFeatureList.find(function (item) {
                return item.key === item.tarRelId
            })

                if (currentftrReleaseList.length > 0) {
                    currentftrRelease = currentftrReleaseList[0].ftrRelease;
                } else if (currRelItem && tarRelItem && currRelItem.ftrRelease && tarRelItem.ftrRelease) {
                    currentftrRelease = "current release: " + currRelItem.ftrRelease + "  target release id " + tarRelItem.ftrRelease;
                }

                this.loadFeaturetable2(selFeatureList, currentftrRelease);

        }
        .bind(this);

        this.loadFeaturetable2 = function (SelFeatureobj, currentftrRelease) {

            var colFeature = ['Feature Area', 'Feature', 'Release'],
            fTable = document.createElement("table"),
            fCaption = document.createElement("caption"),
            fTr = fTable.insertRow(-1),
            fTh,
            tableCaption,
            P6EPPM_ProductArray = [],
            P6Pro_ProductArray = [],
            multipleProductsFlag = false,
            headerIntroText = '',
            ProductsNameText = '',

            highestProductRelNumberInReport = 0,
            lowestProductRelNumberInReport = 0,

            highestProductRelArray = [],
            lowestProductRelArray = [],

            highestProductRelText = '',
            lowestProductRelText = '';

            var myProductobj = {};
            var myProductArray = new Array();

            for (var i = 0; i < SelFeatureobj.length; i++) {
                myProductobj[SelFeatureobj[i]['product']] = SelFeatureobj[i]['product'];
            }

            for (const[product]of Object.entries(myProductobj)) {
                myProductArray.push({
                    product: `${product}`
                });

            }

            P6EPPM_ProductArray = SelFeatureobj.filter(function (SelFeatureobj) {
                return SelFeatureobj.product === "P6 EPPM"
            });

            P6Pro_ProductArray = SelFeatureobj.filter(function (SelFeatureobj) {
                return SelFeatureobj.product === "P6 Professional"
            });

            // var myProductArray = SelFeatureobj.filter(function(SelFeatureobj) { return SelFeatureobj.product ===UniqueProductIndex2});


            // highestProductRelNumberInReport = Math.max(...SelFeatureobj.map(o=>o.index));
            // lowestProductRelNumberInReport = Math.min(...SelFeatureobj.map(o=>o.index));

            highestProductRelNumberInReport = Math.max.apply(null, SelFeatureobj.map(o => o.index));
            lowestProductRelNumberInReport = Math.min.apply(null, SelFeatureobj.map(o => o.index));

            if (highestProductRelNumberInReport === Infinity) {
                $('#curMsgDiv').css("display", "inline");
                return false;
            } else if (lowestProductRelNumberInReport === Infinity) {
                const newDiv = document.createElement("div");
                $('#curMsgDiv').css("display", "inline");
                return false;
            } else {
                $('#curMsgDiv').css("display", "none");
            }

            highestProductRelArray = SelFeatureobj.filter(function (SelFeatureobj) {
                return SelFeatureobj.index === String(highestProductRelNumberInReport)
            });
            // decided to use the current release
            lowestProductRelArray = SelFeatureobj.filter(function (SelFeatureobj) {
                return SelFeatureobj.index === lowestProductRelNumberInReport
            });

            // lowestProductRelNumberInReport=currRelId;


            if (highestProductRelArray.length > 0) {
                highestProductRelText = highestProductRelArray[0].ftrRelease;
            }

            if (currentftrRelease && currentftrRelease !== "") {
                lowestProductRelText = currentftrRelease;
            } else if (lowestProductRelArray.length > 0) {
                lowestProductRelText = lowestProductRelArray[0].ftrRelease;
            } else {
                lowestProductRelText = ""
            }

            /* this version just selects the items that actually appear in the report

            if(myProductArray.length && myProductArray.length === 1){
            ProductsNameText=myProductArray[0].product;
            multipleProductsFlag = false;
            }
            if (myProductArray.length && myProductArray.length === 2) {
            multipleProductsFlag = true;
            ProductsNameText= myProductArray[0].product + " and " + myProductArray[1].product;
            }
            if (myProductArray.length && myProductArray.length > 2) {
            multipleProductsFlag = true;
            for(var i=0; i < myProductArray.length; i++) {
            if (i === 0) {
            ProductsNameText= myProductArray[0].product;
            } else if ((i > 0) && (i < (myProductArray.length - 1))) {
            ProductsNameText= ProductsNameText + " , " + myProductArray[i].product;
            } else if (i === (myProductArray.length - 1)) {
            ProductsNameText= ProductsNameText +  ", and " + myProductArray[i].product;
            }
            }
            }
             */
            // this version contains the items that are selected
            // the items only appear in the report if there is a value
            if (this.selectedProduct._latestValue.length && this.selectedProduct._latestValue.length === 1) {
                ProductsNameText = this.selectedProduct._latestValue[0];
                multipleProductsFlag = false;
            }
            if (this.selectedProduct._latestValue.length && this.selectedProduct._latestValue.length === 2) {
                multipleProductsFlag = true;
                ProductsNameText = this.selectedProduct._latestValue[0] + " and " + this.selectedProduct._latestValue[1];
            }
            if (this.selectedProduct._latestValue.length && this.selectedProduct._latestValue.length > 2) {
                multipleProductsFlag = true;
                for (var i = 0; i < this.selectedProduct._latestValue.length; i++) {
                    if (i === 0) {
                        ProductsNameText = this.selectedProduct._latestValue[0];
                    } else if ((i > 0) && (i < (this.selectedProduct._latestValue.length - 1))) {
                        ProductsNameText = ProductsNameText + " , " + this.selectedProduct._latestValue[i];
                    } else if (i === (this.selectedProduct._latestValue.length - 1)) {
                        ProductsNameText = ProductsNameText + ", and " + this.selectedProduct._latestValue[i];
                    }
                }
            }

            //selectedProduct._latestValue[i];

            headerIntroText = ProductsNameText;

            tableCaption = headerIntroText + " " + '<span class="largehorizontalSpace"> </span>';
            tableCaption = tableCaption + lowestProductRelText + " - " + highestProductRelText;
            tableCaption = tableCaption + ' Release Feature Overview';

            fCaption.innerHTML = tableCaption;
            fTable.appendChild(fCaption);

            //creating the table header row
            for (var i = 0; i < colFeature.length; i++) {

                switch (i) {
                case 0:
                    if (multipleProductsFlag) {
                        fTh = document.createElement("th");
                        fTh.setAttribute("class", "multipleProduct");
                        fTh.innerHTML = colFeature[i];
                        fTr.appendChild(fTh);
                    } else {
                        fTh = document.createElement("th");
                        fTh.setAttribute("class", "singleProduct");
                        fTh.innerHTML = colFeature[i];
                        fTr.appendChild(fTh);
                    }
                    break;
                case 1:
                    if (multipleProductsFlag) {
                        fTh = document.createElement("th");
                        fTh.setAttribute("class", "multipleProductFeat");
                        fTh.innerHTML = colFeature[i];
                        fTr.appendChild(fTh);
                    } else {
                        fTh = document.createElement("th");
                        fTh.setAttribute("class", "singleProductFeat");
                        fTh.innerHTML = colFeature[i];
                        fTr.appendChild(fTh);
                    }
                    break;

                case 2:
                    if (multipleProductsFlag) {
                        fTh = document.createElement("th");
                        fTh.setAttribute("class", "multipleProductRel");
                        fTh.innerHTML = colFeature[i];
                        fTr.appendChild(fTh);
                    } else {
                        fTh = document.createElement("th");
                        fTh.setAttribute("class", "singleProductRel");
                        fTh.innerHTML = colFeature[i];
                        fTr.appendChild(fTh);
                    }

                    break;
                }
            }

            //filling the rows of table with data
            for (var i = 0; i < SelFeatureobj.length; i++) {

                fTr = fTable.insertRow(-1);

                for (var j = 0; j < colFeature.length; j++) {
                    var ftabCell = fTr.insertCell(-1);
                    switch (j) {
                    case 0:
                        if (multipleProductsFlag) {
                            ftabCell.innerHTML = SelFeatureobj[i].product;
                            ftabCell.setAttribute("class", "multipleProduct");
                        } else {
                            ftabCell.innerHTML = SelFeatureobj[i].product;
                            ftabCell.setAttribute("class", "singleProduct");
                        }
                        break;
                    case 1:
                        var brk = SelFeatureobj[i].feature.split('\n');
                        var res = brk.join(" <br> ");
                        ftabCell.innerHTML = res;
                        if (multipleProductsFlag) {
                            ftabCell.setAttribute("class", "multipleProductFeat");
                        } else {
                            ftabCell.setAttribute("class", "singleProductFeat");
                        }
                        break;
                    case 2:
                        if (multipleProductsFlag) {
                            ftabCell.innerHTML = SelFeatureobj[i].ftrRelease;
                            ftabCell.setAttribute("class", "multipleProductRel");
                        } else {
                            ftabCell.innerHTML = SelFeatureobj[i].ftrRelease;
                            ftabCell.setAttribute("class", "singleProductRel");
                        }
                        break;
                    }

                }

            }

            var HTMLDocument,
            HTMLTag,
            headTag,
            beginHTMLTag,
            endHTMLTag,
            BODYTAG,
            beginBODYTAG,
            endBODYTAG,
            headerDiv,
            contentBodyDiv

            beginHTMLTag = '<!DOCTYPE html>';
            beginHTMLTag = beginHTMLTag + '<html lang="en-us">';
            headTag = '<head>';
            headTag = headTag + '<meta charset="UTF-8"><meta name="viewport" content="viewport-fit=cover, width=device-width, initial-scale=1"/>';
            headTag = headTag + '<title>';
            headTag = headTag + this.appName;
            headTag = headTag + ' Cumulative Feature Overview</title>';
            headTag = headTag + '<link rel="icon" href="css/images/favicon.ico" type="image/x-icon" />';
            headTag = headTag + '<link rel="stylesheet" href="css/redwood/9.1.0/web/redwood.css" id="css" />';
            headTag = headTag + '<link rel="stylesheet" href="css/demo-alta-site-min.css" type="text/css"/>';
            headTag = headTag + '<link rel="stylesheet" id="uxiconFont" href="https://static.oracle.com/cdn/fnd/gallery/2010.0.0/images/iconfont/ojuxIconFont.min.css"/>';
            headTag = headTag + '<link rel="stylesheet" href="css/app.css" type="text/css" />';
            headTag = headTag + '</head>';
            // headTag=stringToHTML(headTag);


            HTMLTag = beginHTMLTag;

            beginBODYTAG = '<body class="oj-web-applayout-body">';

            BODYTAG = beginBODYTAG + '<div id="globalBody2" class="oj-web-applayout-page">'

                headerDiv = '<header role="banner" class="oj-web-applayout-header">'
                headerDiv = headerDiv + '<div class="oj-web-applayout-max-width oj-flex-bar oj-sm-align-items-center">'
                headerDiv = headerDiv + '<div class="oj-flex-bar-middle oj-sm-align-items-baseline">'
                headerDiv = headerDiv + '<h1 class="oj-sm-only-hide oj-web-applayout-header-title" title="Application Name">'
                headerDiv = headerDiv + this.appName;
            headerDiv = headerDiv + ' Cumulative Feature Overview';
            headerDiv = headerDiv + '</h1>'
                headerDiv = headerDiv + '</div>'
                headerDiv = headerDiv + '</div>'
                headerDiv = headerDiv + '</header>'

                BODYTAG = BODYTAG + headerDiv;

            contentBodyDiv = '<div role="main" class="oj-web-applayout-max-width oj-web-applayout-content custom-report">'

                BODYTAG = BODYTAG + contentBodyDiv

                var tableDivBegin = '<div class="tableDiv">';
            /*
            tableDivBegin = tableDivBegin + '<h1>'
            tableDivBegin = tableDivBegin + headerIntroText + " " + '<span class="largehorizontalSpace"> </span>';
            tableDivBegin = tableDivBegin + lowestProductRelText + " - " + highestProductRelText;
            tableDivBegin = tableDivBegin + ' Release Feature Overview';
            tableDivBegin = tableDivBegin + '</h1>'
             */

            BODYTAG = BODYTAG + tableDivBegin + fTable.outerHTML + '</div></div></div>'

                endBODYTAG = '</body>';
            BODYTAG = BODYTAG + endBODYTAG;

            endHTMLTag = '</html>';

            HTMLTag = HTMLTag + headTag + BODYTAG + endHTMLTag;

            HTMLDocument = HTMLTag;

            var wnd = window.open("", "_blank", "location=0,toolbar=0");

            wnd.document.write(HTMLDocument);

            var footerDiv = document.getElementById("footerDiv");
            var footerDivClone = footerDiv.cloneNode(true);
            var bodyElement = wnd.document.getElementsByTagName('body')[0];
            wnd.document.getElementsByTagName('body')[0].appendChild(footerDivClone);
            wnd.document.getElementsByTagName('html')[0].appendChild(bodyElement);

            wnd.moveTo(0, 0);
            wnd.resizeTo(screen.availWidth, screen.availHeight);
            wnd.window.focus();

        }
        .bind(this);

        function getSearchString() {
            var name,
            value;
            var args = {};
            var query = location.search.substring(1);
            if (!query)
                return;
            var pairs = query.split("&");
            for (var i = 0; i < pairs.length; i++) {
                var pos = pairs[i].indexOf('=');
                if (pos === -1)
                    continue;
                if (pairs[i].substring(0, pos) === "product" | pairs[i].substring(0, pos) === "version") {
                    name = pairs[i].substring(0, pos);
                    value = pairs[i].substring(pos + 1);
                    value = value.replace(/%20/g, " ").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
                    value = value.toLowerCase();
                    args[name] = value;
                }
            }
            if (args) {
                return args;
            } else {
                return false;
            }
        }

    }

    Bootstrap.whenDocumentReady().then(function () {
        if (document.getElementById("globalBody")) {
            ko.applyBindings(new viewModel(), document.getElementById("globalBody"));
        }
    });

});
